//
//  RSmartLock.m
//  R
//
//  Created by Byron Ellis on 2/27/07.
//  Copyright 2007 __MyCompanyName__. All rights reserved.
//

#import "RSmartLock.h"


@implementation RSmartLock
- (id)init {
	if(nil == [super init]) return nil;
	lockCount = 0;
	return self;
}

- (void)lock {
	lockCount++;
	NSLog(@"lock %d",lockCount);
	[super lock];
}
- (void)unlock {
	NSLog(@"unlock %d",lockCount);	
	if(lockCount > 0) {
		[super unlock];
		lockCount--;
	} 
}

- (BOOL)tryLock {
	BOOL r = [super tryLock];
	if(YES == r) {
		lockCount++;
		NSLog(@"tryLock %d",lockCount);		
	} else
	NSLog(@"tryLock failed %d",lockCount);
	return r;
}

@end
